#include <unistd.h>

#include <time.h>
#include <SDL/SDL.h>
#include "SDL/SDL_ttf.h"
#include "SDL/SDL_image.h"
#include "SDL/SDL_mixer.h"

#include "main.h"
#include "xgrafi.h"
#include "objetos.h"


char CLAVE[] = "PULSV3";

#define TIEMPO1		7 	//pulso
#define xtimePort	5	//Lectura serie
#define TIEMPO3		2	//pintar punto


int tiempo1=TIEMPO1,timePort=xtimePort, tiempo3=TIEMPO3;

Boton *Bacerca;
Boton *Bexit;
TextoS *Titulo;
TextoE *Tdivisor;
TextoE *Bdevice;
SpinBox * Sdesplazamiento;
TextoS  *Tdesplaza;
TextoS	*BPM;
SpinBoxS *Szoom;
CBoton *BModoDibujo;
       
void Repaint(void);

//_____
void MiTimer();

int SearchPort2(void);
void CalldivisorSelect(void);
void OnSzoomSelect(void);
void Representar(int z);
void ModifiG();
void pintarPunto(void);
void analizar(void);

#define MAXENTRADA 50
#define MAXINPUT 100

int  ContadorI=0;
char Binput[MAXINPUT];
char Binput2[10];
char FinContador=1;

int PAUSA;
int ZOOM=1;
int INDEX=0;

int xx;

unsigned char portok;
bool PULSO;

int val0,val1,val2;
int anteriorVal;
int pantaX=800,pantaY=450;

//_________________________

#if YesWindows
    static 	char *myport[]= {"com1","com2","com3","com4","com5","com6","com7","com8","com9","\\\\.\\COM10","\\\\.\\COM11","\\\\.\\COM12"};
#else
	static char *myport[]= {(char *)"/dev/ttyUSB0", (char *)"/dev/ttyUSB1", (char *)"/dev/ttyACM0", (char *)"/dev/ttyACM1", (char *)"/dev/ttyACM2", (char *)"/dev/ttyS0", (char *)"/dev/ttyS1"};
#endif	

void PrintConsola( char *texto)
{
  Bdevice->Value( (char *) texto);
  Bdevice->Dibujar();
  SDL_Flip( screen );
}

int main (int argc, char *argv[])
{
	int quit = 0;
	int mouse_x,mouse_y;
	Uint8 *teclas; 	
	int SimbolKey;
	int z;
		
	
	if(init(pantaX,600) == 0 ) return 1;
	
	SDL_FillRect( screen, NULL, SDL_MapRGB( screen->format, 0x15, 0xaa, 0x30 ) );
	if( SDL_Flip( screen ) == -1 ) return 3;
	//if (load_files((char*)"modelo2.png",NULL,(char*)"seta.ttf") == 0 ) return 2;
	if (load_files(NULL,NULL,(char*)"setam.ttf") == 0 ) return 2;
	
//_______________________	
	Bacerca=new Boton(560,660,(char*)"Acerca");
	Bexit=new Boton(672,554,(char*)"Salir");

	Titulo=new TextoS(304,484,(char*) "PulsoSDLv1");
	BPM=new TextoS(120,554,(char*) "BPM");
	Tdivisor=new TextoE(10,554,(char*) "Pulsos");
	Bdevice=new TextoE(374,554,205,24,(char*) "device");
	Sdesplazamiento=new SpinBox(10,492,80,24,-120,120,10);
	Tdesplaza=new TextoS(100,494,(char*) "Desplazar");
	
	Szoom=new SpinBoxS(10,524,80,24);
	Szoom->Append((char*)"/4");
	Szoom->Append((char*)"/2");
    Szoom->Append((char*)"X1");
    Szoom->Append((char*)"X2");
    Szoom->Append((char*)"X4");
	
    BModoDibujo=new CBoton(250,554,(char*) "PAUSE");

	Representar(0);
	Repaint();

#if YesWindows
	MiBAUDIOS=CBR_115200;
    if(hSerial)CloseRs232();
#else 
	MiBAUDIOS=B115200;
    if(fdrs232)CloseRs232();    
#endif	
	
	z=SearchPort2();

	if(z==-1)
			 { 
				 printf("No %s\n",CLAVE);
				 Bdevice->Value( (char *) "No device");
			 }
			else
		     { 
				portok=1;
				MODEMDEVICE=myport[z];
	#if YesWindows
				if(hSerial)CloseRs232();
	#else		
				if(fdrs232)CloseRs232();
	#endif		 
				IniRs232();				
				Bdevice->Value(MODEMDEVICE);
			 }
		
	PAUSA=0;
	BModoDibujo->SetValue(PAUSA);
	BModoDibujo->SetLabel((char *) "PAUSE" );
	
	Sdesplazamiento->SetValue(100);
	
	ModifiG();	
	Repaint();
	
//________________________
		
	while( quit == 0 )
	{	
		SDL_Delay(15);	  
		MiTimer();								  	  
		while( SDL_PollEvent( &event ) )
		{
			teclas = SDL_GetKeyState(NULL);
			if (teclas[SDLK_UP])     printf("ARRIBA Keys Pressed.\n");
			if (teclas[SDLK_RIGHT])  printf("DERECHA Keys Pressed.\n");	
			if (teclas[SDLK_RIGHT] && teclas[SDLK_UP])  printf("DOS teclas Pressed.\n");				
			switch (event.type)			
			{				
				case	SDL_KEYDOWN:
						SimbolKey=event.key.keysym.sym;	
						#ifdef DEBUG 
							printf("Evento Tecla  %d\n",SimbolKey);
						#endif										
						switch (SimbolKey)			
							{				
								case	SDLK_F1:
										#if YesWindows
											screen = SDL_SetVideoMode( SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP,SDL_FULLSCREEN | SDL_SWSURFACE );
										#else
											SDL_WM_ToggleFullScreen(screen);
										#endif  						
								break;
								case	SDLK_F2:
										screen = SDL_SetVideoMode( SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP, SDL_SWSURFACE );						
										Representar(0);
										Repaint();
								break;
								case	SDLK_ESCAPE:
										quit=1;
								break;
								case	SDLK_r:
										Repaint();
								break;
							}					
				break;
				case	SDL_MOUSEBUTTONDOWN:
					mouse_x=event.button.x;
					mouse_y=event.button.y;				
					#ifdef DEBUG 
						printf("Evento Raton Abajo X=%d Y=%d Nboton=%d\n",mouse_x,mouse_y,event.button.button);	
					#endif
					
					
					if(Bexit->get(mouse_x,mouse_y)) 
						{
//						 printf("SI boton Bsalir\n");
						 Bexit->Dibujar(1);
						 quit=1;
						 goto salir1;
						}				
//_Desplazamiento
					z=Sdesplazamiento->get(mouse_x,mouse_y);
					if(z==2) 	{	Sdesplazamiento->Decrem();  
									Representar(1);	ModifiG(); goto salir12;	}
					if(z==1) 	{	Sdesplazamiento->Increm(); 
									Representar(1);	ModifiG(); goto salir12;	}					
//__Zoom___
					z=Szoom->get(mouse_x,mouse_y);
					if(z==2) 	{	Szoom->Decrem();  ModifiG(); Representar(1); goto salir1;	}
					if(z==1) 	{	Szoom->Increm();  ModifiG(); Representar(1); goto salir1;	}
//___LINE___POINT__
					if(BModoDibujo->get(mouse_x,mouse_y))
						{
						 if(BModoDibujo->GetValue()) 
							{
							 PAUSA=0;
							 BModoDibujo->SetValue(PAUSA);
							 BModoDibujo->SetLabel((char *) "PAUSE" );
							}
							else
							{
							 PAUSA=1;
							 BModoDibujo->SetValue(PAUSA);
							 BModoDibujo->SetLabel((char *) "noPAUSE");
							}
						 BModoDibujo->Dibujar();						 
						 goto salir1;						 
						}
					
					goto salir12;
salir1:						
					SDL_Flip( screen );
salir12:
				break;
				case	SDL_MOUSEBUTTONUP:
					mouse_x=event.button.x;
					mouse_y=event.button.y;
					Repaint();									
					#ifdef DEBUG 
						printf("Boton Arriba X=%d Y=%d \n",mouse_x,mouse_y);
					#endif	
				break;
				case	SDL_QUIT:
					quit = 1;
				break;		
			}			
		}
	}
	
//	salir: 
//Cerrar todo el SDL
	clean_up();
	#ifdef DEBUG 
		printf("Fin\n");
	#endif	
	SDL_Delay(500);
	return 0;  
}


void Repaint(void)
{
	Bexit->Dibujar();
	//Bacerca->Dibujar();	
	setcolor(253,251,7); 
	//Titulo->DibujarColor();
	PrintTexto(250,492,(char*) "PulsoSDLv3",font2);
	
	Sdesplazamiento->Dibujar();
	BPM->Dibujar();
	Tdesplaza->Dibujar();
	Szoom->Dibujar();	
	Tdivisor->Dibujar();
	BModoDibujo->Dibujar();
	Bdevice->Dibujar();
						
	SDL_Flip( screen );
}


void pintarPunto(void)
{
	setcolor(255,255,255);
	line(xx-2,0,xx-2,5);
	line(xx,0,xx,pantaY);
	line(xx+1,0,xx+1,pantaY);
	
	setcolor(255,0,0);
	line(xx,0,xx,5);
	
	switch(ZOOM)
	{
		case 0:
		val0=val0/4;
		break;
		case 1:
		val0=val0/2;	
		break;
		case 2:
		val0=val0;	
		break;
		case 3:
		val0=val0*2;	
		break;
		case 4:
		val0=val0*4;	
		break;
	}	
	val0=pantaY-val0;
	
	if(anteriorVal-INDEX>0 && anteriorVal-INDEX<pantaY && val0-INDEX>0 && val0-INDEX<pantaY )
		{
			setcolor(0,0,255);
			line(xx-2,anteriorVal-INDEX,xx,val0-INDEX);
		}
	anteriorVal=val0;
	if(PAUSA==0)xx+=2;
	if(xx>pantaX) xx=0;
}

//_______________________________
void analizar(void)
{
		
	char *ptr = strtok(VARI, ",");
		if(ptr== NULL) { goto salir1;}
		val0=atoi(ptr);
		ptr = strtok(NULL, ",");
		if(ptr== NULL) {  goto salir1;}
		val1=atoi(ptr);
		ptr = strtok(NULL, ",");
		if(ptr== NULL) {  goto salir1;}
		val2=atoi(ptr);
//		printf("%d_%d_%d_\n",val0,val1,val2);
		
		Tdivisor->Value(val1);
		Tdivisor->Dibujar();
		if(val2==1)
		{
			PULSO=1;
			tiempo1=TIEMPO1;
			setcolor(255,0,0);
			bar( 540, 494, 572, 526 );		
		}
		pintarPunto();
		SDL_Flip( screen );
salir1:
	;
}
//________________________________________
void ModifiG()
{
		INDEX=Sdesplazamiento->GetValue();
		ZOOM=Szoom->GetValue();
#ifdef BOTONES 	
	printf("ZOOM=%d    DESPLAZAMIENTO=%d    \n",ZOOM,INDEX);
#endif

}	

void  Representar(int z)
{
	setcolor(255,255,255);
	bar( 0, 0, pantaX, pantaY );	
	xx=0;
	SDL_Flip( screen );
}


//____________________FIN____________


void MiTimer()
{
 int nbytes;
 
	tiempo1--;	
	timePort--;	
	tiempo3--;
	
// cada __tiempo1
	if(tiempo1<0)
		{	
			tiempo1=TIEMPO1;
			if(PULSO==1)
			{
				PULSO=0;
				setcolor(0,255,0);
				bar( 540, 494, 572, 526 );
				SDL_Flip( screen );
			}
			
		}

// cada __timePort
	 if(portok==1 && timePort<0)
    {
        timePort=xtimePort;
        
#if YesWindows
		while(( nbytes = ReadSerie(hSerial, Binput2, 1)>0 ))
#else		
			while(( nbytes = read(fdrs232, Binput2, 1)>0 ))
#endif			
			{
			 	Binput[ContadorI]=Binput2[0];
				if(ContadorI<MAXINPUT-2)   ContadorI++;
				
				if (Binput2[0] == '\n')
					{
						if(ContadorI<2)ContadorI=2;   
						Binput[ContadorI-1]=0;
						ContadorI=0;	
						sprintf(VARI,"%s",Binput);
						analizar();
					}									
			}
		}	

// cada __tiempo3 
		if(tiempo3<0)
		{
			tiempo3=TIEMPO3;
			//printf("tiempo3\n");			
			//pintarPunto();			
		}						
}

//______________

int SearchPort2(void)
{
		int z,zz,nbytes;
		
//		printf("Search serial\n");
//		PrintConsola((char *)"Search serial");
 #if YesWindows
		for (z=0;z<11;z++)
 #else
			for (z=0;z<7;z++)
 #endif		
			{
				MODEMDEVICE=myport[z];
				printf("Test Port %s\n",MODEMDEVICE);
				PrintConsola(MODEMDEVICE);
				if(0==IniRs232())
				   {   
//					printf("->busqueda>%s   %s\n",MODEMDEVICE,CLAVE);            
					DelayMs(1000);

					ContadorI=0; 
					for(zz=0;zz<20;zz++)
					   {
						DelayMs(100); 
#if YesWindows
						while(( nbytes = ReadSerie(hSerial, Binput2, 1)>0 ))
#else		
						while(( nbytes = read(fdrs232, Binput2, 1)>0 ))
#endif		
							{	
//							    printf("Leerx %d -> %s\n",nbytes,Binput2);
								Binput[ContadorI]=Binput2[0];
								if(ContadorI<MAXINPUT-2)   ContadorI++;
								if (Binput2[0] == '\n')
								   {
									if(ContadorI<2)ContadorI=2;   
									Binput[ContadorI-1]=0;
									ContadorI=0;	
									sprintf(VARI,"%s",Binput);
//                                    printf("==%s\n",VARI);
									if(!strncmp(VARI,CLAVE,2))
									   {
										printf("%s found at %s\n",CLAVE,MODEMDEVICE);
										CloseRs232();
										portok=1;                                   
										return z ;
									   }			
								    }
							}	  	  
						} 
						 					 						   
					}
			 }
			printf("PULSE no found \n");
	return -1;
}


